/*
Copyright The KCP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"

	v1alpha1 "github.com/kcp-dev/kcp/pkg/apis/apis/v1alpha1"
)

// FakeAPIBindings implements APIBindingInterface
type FakeAPIBindings struct {
	Fake *FakeApisV1alpha1
}

var apibindingsResource = schema.GroupVersionResource{Group: "apis.kcp.dev", Version: "v1alpha1", Resource: "apibindings"}

var apibindingsKind = schema.GroupVersionKind{Group: "apis.kcp.dev", Version: "v1alpha1", Kind: "APIBinding"}

// Get takes name of the aPIBinding, and returns the corresponding aPIBinding object, and an error if there is any.
func (c *FakeAPIBindings) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.APIBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(apibindingsResource, name), &v1alpha1.APIBinding{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.APIBinding), err
}

// List takes label and field selectors, and returns the list of APIBindings that match those selectors.
func (c *FakeAPIBindings) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.APIBindingList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(apibindingsResource, apibindingsKind, opts), &v1alpha1.APIBindingList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.APIBindingList{ListMeta: obj.(*v1alpha1.APIBindingList).ListMeta}
	for _, item := range obj.(*v1alpha1.APIBindingList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aPIBindings.
func (c *FakeAPIBindings) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(apibindingsResource, opts))
}

// Create takes the representation of a aPIBinding and creates it.  Returns the server's representation of the aPIBinding, and an error, if there is any.
func (c *FakeAPIBindings) Create(ctx context.Context, aPIBinding *v1alpha1.APIBinding, opts v1.CreateOptions) (result *v1alpha1.APIBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(apibindingsResource, aPIBinding), &v1alpha1.APIBinding{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.APIBinding), err
}

// Update takes the representation of a aPIBinding and updates it. Returns the server's representation of the aPIBinding, and an error, if there is any.
func (c *FakeAPIBindings) Update(ctx context.Context, aPIBinding *v1alpha1.APIBinding, opts v1.UpdateOptions) (result *v1alpha1.APIBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(apibindingsResource, aPIBinding), &v1alpha1.APIBinding{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.APIBinding), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeAPIBindings) UpdateStatus(ctx context.Context, aPIBinding *v1alpha1.APIBinding, opts v1.UpdateOptions) (*v1alpha1.APIBinding, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(apibindingsResource, "status", aPIBinding), &v1alpha1.APIBinding{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.APIBinding), err
}

// Delete takes name of the aPIBinding and deletes it. Returns an error if one occurs.
func (c *FakeAPIBindings) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(apibindingsResource, name, opts), &v1alpha1.APIBinding{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAPIBindings) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(apibindingsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.APIBindingList{})
	return err
}

// Patch applies the patch and returns the patched aPIBinding.
func (c *FakeAPIBindings) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.APIBinding, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(apibindingsResource, name, pt, data, subresources...), &v1alpha1.APIBinding{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.APIBinding), err
}
